%All parameters listed here
%Swati D. Rane
%April 8, 2005
%---------------------------------------------------
% Copyright (C) 2005 Jim Ji, Texas A&M University.
% All Rights Reserved.

% References:


% Version of 4-June-2005.

% Log:
% Created  2004 Swati Rane	Source code
% Updated
%-----------------------------------------------------

%all parameters required for simulation are listed here.
%parameters for simulated image
Files.data=0;%DO NOT CHANGE
Image_size.dim=0;%DO NOT CHANGE
%------------------------------------
data_type=1;%DO NOT CHANGE
%   2: input a file containing image data
%   3: input fiile containing full kspace data
%   4: input a file containing reduced kspace data
% type: integer
% value: 1 to 4
save parameters data_type;
%_____________________________________
% Files details required for all data_types except 1
%Files.data='cameraman.tif';
%Files.data='data1.mat';
%Files.calibration='center1.mat';
%Files.reference_scan= 'newdata2.mat';
%Files.refrence_image='refimg/mat';
%______________________________________
%Flags details
%flag for deciding type of array
%type: integer
%value - 0: non-linear array
%value - 1: linear array
Flags.lin_flag=1;% may change for every simulation
%------------------------------------
%flag to select polynomial filtering
%type: integer
%to select, value =1;
Flags.poly_tick=0;
%-----------required for SENSE--------
%for regularised SENSE
%type: integer
%value: 0 - no regularization to be performed
%       1 - perform regularization 
%Flags.regularization_flag=0;
%--------required for SMASH- AUTO-SMASH----
%type: integer;
%value: 1;
%Flags.auto_smash_flag=0;
%--------required for SMASH-----------
%flag for tight harmonic fitting in SMASH
%type: integer
%value of 1= fit tightly
%Flags.fit_img=0;
%---------GRAPPA ---------------------
%flag for MCML reconastruction
%type 0
%value 1:use MCMLi
%value 0: conventional GRAPPA
Flags.mcmli_flag=0;
%_______________________________________
% Receiver  details
%--required for image data simulation--
%number of coils
%type: integer
Receiver.num_coils=8;
%always greater than subsampling_factor.
%------------------------------------
%factor determining coil localization
%type: integer
%value: 1 through 20
%if variance_factor=1, then coil is highly localised
%if variance_factor=20, coil is not very localised
Receiver.variance_factor=2;

%------------------------------------
%maximum value of the coil sensitivity. With 1,
% the sensitvity maps are like normalized
% type:rational
% value: 
Receiver.max_sensitivity=1;

%-----------------------------------
%Reference SNR: required when simulating any image data
% type:rational
% value:
Receiver.SNR=20;
%-----------------------------------
%Backgoundphase frequency

Receiver.backgroundphase_freq=0;
%------------------------------------
%Method of sensitivity estimation
%   1: Coil data available already in a file
%      i.e. if reference scans or full FOV scans are available in file
%      ref_data.mat
%   2: Extra Calibration Lines and SOS Method
%      i.e. if only a few lines are collected in the center of the kspace,
%      then sensitivity estimation is done by obtainging low resolution
%      coil images and dividing them by the sum of squares
%   3: Extra Calibration Lines and Walsh Method
%      i.e. coil images are obained using principal component analysis for
%      better back ground noise suppression
Receiver.sensitivity_estimation=2;
%___________________________________
%-----------------------------------
%required for reduced ksapce data simulation
%---required for reduced kspace data simulation--
%type: integer
%total Phase encodings required in case of reduced kspace data inputs
%Image_size.PEs=128;%

%------------------------------------
%type:integer
%total Frequency encodings required in case of reduced kspace data inputs
%Image_size.FEs=128;%

%____________________________________
%Sampling details
%------------------------------------
%reduction factor
%integer values
Sampling.subsampling_factor=2;
%always less than number of coils, num_coils
%------------------------------------
%Sampling.sampling_location=[1:16 17:4:57 58:72 73:4:112 113:128];
%Sampling.sampling_location=1:Sampling.subsampling_factor:Image_size.PEs;
%ROW VECTOR
        % sampling_locations can be 1) 1:subsampling_factor:PEs
        %                           2) 2:subsampling_factor:PEs
        %                           3) non-uniform, in which case the
        %                              vector containing locatins must be
        %                             
%default direction of subsampling is X i.e. columns will be reduced
%------------------------------------
Sampling.direction='X'; %can be 'X' or 'Y'.
% ----extra lines position----------
% must be a ROW VECTOR
% defined either as eg. 1:2:128
% OR as [1 3 5 7 9 ...]
Sampling.center_locs=56:71;
%Sampling.center_locs=64;%for AUTO-SMASH
%Sampling.center_locs=120:134;%must be entered 
%Sampling.center_locs=112:143
%Sampling.center_locs=105:136
%-----------------------------------
%number of lines (acquired+extra) for sensitivity estimation
%type: integer
Sampling.center_lines=length(Sampling.center_locs);
%____________________________________
%------------------------------------
%choose image reconstruction method
%type: integer
%value: 1 to 5
%   1: SENSE
%   2: PILS
%   3: SMASH
%   4: GRAPPA
%   5: SPACE RIP
option=4;
%___________________________________
%Miscellaneous----------------------
%if fit_img=1, then space occupied by object in the FOV is required
%eg. 50% of the FOV is occupied by the object
%type: rational
%value: 1 to 100
%Misc.per=75;%
%------------------------------------

%-----required for SPACE RIP---------
%type: integer
%choose sampling type in SPACE RIP
%   1: uniform
%   2: Only central lines
%   3: Alternate central lines
%   4: Non-uniform sampling
%    5: Uniform sampling but use the ACS
%usually options 2,3 result ina higher condition number of ther
%econstruction matrix and hence a poor reconstruction
%Misc.samp=4;%required for SPACE RIP only

%--------requird for GRAPPA---------
Misc.recons=1;
Misc.blocks=2;
%----------------------------------
%---------DO NOT CHANGE--------------

%_____________________________________
%-----performance analysis------------
%select performane analysis parameter
% type: integer
% value: 1 to 6
%   1: box SNR
%   2: SNR with 2 acquisitions
%   3: pixel-wise SNR
%   4: artifact power
%   5: resolution  -not included
%   6: no performance analysis
per_list=6;
save parameters;
%_______________________________________
