function [sensitivity_new]=sensitivity_polyfilt(sensitivity,Np,Rx,Ry);
%function [sen_new]=sensitivity_polyfilt(sensitivity,Np,Rx,Ry);
% input: raw sensitivity;
% Rx, Ry: the range of neighboring pixels considered in polynomial fitting,
% in half, i.e., -Rx:Rx will be neighbors; x is vertical, y is horizental
% Np: order of polynomial 2D
% output: filtered sensitivity_new: 
%----------------------------------------------
% Copyright (C) 2005 Jim Ji, Texas A&M University.
% All Rights Reserved.

% References:


% Version of 4-June-2005.

% Log:
% Created  2003 Jim Ji	Source code
% Updated
%-----------------------------------------------------
[Nx,Ny,Ncoils]=size(sensitivity);

%construct the distance polynomial matrix

[dy,dx]=meshgrid( (-Rx):(Rx), (-Ry):(Ry) ); dx=dx(:); dy=dy(:);
N=(2*Rx+1)*(2*Ry+1);
A=ones(N,1);

if Np==1
    A=[A dx dy dx.*dy]; 
    
else if Np==2
    A=[A dx dy dx.*dy dx.*dx dy.*dy dx.*dx.*dy dx.*dy.*dy dx.*dx.*dy.*dy]; 
end
end

invA = pinv(A);

sensitivity_new = sensitivity;
for coil = 1:Ncoils
    coil;
    for i= (Rx+1):(Nx-Rx)
        for j= (Ry+1):(Ny-Ry)
            measured_s = sensitivity((i-Rx):(i+Rx),(j-Ry):(j+Ry),coil);
            tmp = invA*measured_s(:);
            sensitivity_new(i,j,coil) = tmp(1);
        end
    end
end
return