function temp_col=gencol_gen(nacs,kspread,subsampling_factor,PEs,FEs,start,i,column,num_coils,consider_coils,blocks,bk,take_cols,mcmli)
% Swati D. Rane
% TAMU, July, 2004
%--------------------------------------------------
%---------------------------------------------------
% Copyright (C) 2005 Jim Ji, Texas A&M University.
% All Rights Reserved.

% References:Generalized Autocalibrating Partially Parallel Acquisitions (GRAPPA)
%            M. Griswold
%            Magnetic Resonance in Medicne, 47:1202-1210 (2002)


% Version of 4-June-2005.

% Log:
% Created  2004 Swati Rane	Source code
% Updated
%-----------------------------------------------------
switch bk
    case 1
        start=start-subsampling_factor*(blocks/2-1);
    case 2
        start=start-subsampling_factor*(blocks/2-1)-subsampling_factor;
    case 3
        start=start-subsampling_factor*(blocks/2-1)+subsampling_factor;
    case 4
        start=start-subsampling_factor*(blocks/2-1)+2*subsampling_factor;
end
r=0;
if(i<=ceil(consider_coils/2))
   take=[1:consider_coils];
elseif(i+ceil(consider_coils/2)>num_coils)
   take=[num_coils-consider_coils+1:num_coils];
else
   take=[i-ceil(consider_coils/2)+1:i+ceil(consider_coils/2)];
end

   for jt=take(1):take(consider_coils)
        ksptemp=kspread(:,column,jt);
        if start+(nacs/4)*subsampling_factor+nacs/2 >=PEs
            temp=start+(nacs/4)*subsampling_factor-PEs;
            ksptemp(ceil(PEs+temp+nacs/2),:)=0;
            [Npe1 Nfe1]=size(kspread);
            pos=start;
        else
            ksptemp=kspread(:,column,jt);
            Npe1=PEs;
            Nfe1=FEs;
            pos=start;
        end
        for(m=1:blocks)           %nacs/2
           if pos<=0
              temp_col(r+1,:)=0;
              [r trash]=size(temp_col);
           elseif pos>PEs
              temp_col(r+1,:)=0;
              [r trash]=size(temp_col);
           else
                cp=1;
             %for(c=1:Misc.mcmli)
                 temp_col(r+1,cp:cp+mcmli-1)=ksptemp(pos,:);
              %   cp=cp+Misc.mcmli;
              %end               
             [r trash]=size(temp_col);
             
           end
           pos=pos+subsampling_factor;        
        end      
    end

return