function temp_coil=genmat_gen(nacs,kspread,subsampling_factor,PEs,FEs,start,i,num_coils,consider_coils,blocks,take_cols,mcmli)
%Swati D. Rane
%TAMU, July, 2004
%----------------------------------------------------------
% generates the matrix of coil sensitivity values to solve
% simultaneously for the coefficents for reconstructing missed lines
% input= nacs, spread kspace data, PEs, FEs,total coils, ciols for coeff.
% calculation
%-----------------------------------------------------------------------
%---------------------------------------------------
% Copyright (C) 2005 Jim Ji, Texas A&M University.
% All Rights Reserved.

% References: Generalized Autocalibrating Partially Parallel Acquisitions (GRAPPA)
%             M. Griswold
%             Magnetic Resonance in Medicne, 47:1202-1210 (2002)

% Version of 4-June-2005.

% Log:
% Created  2004 Swati Rane	Source code
% Updated
%-----------------------------------------------------
r=0;
if(i<=ceil(consider_coils/2))
   take=[1:consider_coils];
elseif(i+ceil(consider_coils/2)>num_coils)
   take=[num_coils-consider_coils+1:num_coils];
else
   take=[i-ceil(consider_coils/2)+1:i+ceil(consider_coils/2)];
end
 for n=1:floor(nacs/(subsampling_factor-1))%JAn 22, 2005
   for j=take(1):take(consider_coils)
        ksptemp=kspread(:,:,j);
        if start+(nacs/4)*subsampling_factor+nacs/2 >=PEs
            temp=start+(nacs/4)*subsampling_factor-PEs;
            ksptemp(PEs+temp+nacs/2,:)=0;
            [Npe1 Nfe1]=size(kspread);
            pos=start;
        else
            ksptemp=kspread(:,:,j);
            Npe1=PEs;
            Nfe1=FEs;
            pos=start;
        end
        for(m=1:blocks)%nacs/2
           if pos<=0
              temp_coil(r+1,:)=zeros(1,FEs);
              [r trash]=size(temp_coil);
           elseif pos>PEs
              temp_coil(r+1,:)=zeros(1,FEs);
              [r trash]=size(temp_coil);
           else
             cp=1;
               for(c=1:Nfe)
                 temp_coil(r+1,cp:cp+mcmli-1)=ksptemp(pos,take_cols(c,:));
                 cp=cp+mcmli;
               end
               [r trash]=size(temp_coil);
           end
           pos=pos+subsampling_factor;        
        end      
    end
    start=start+subsampling_factor;
end
return