function [reduced_kspace_data,sampling_location]= subsamp(data_type,full_kspace_data,samp,num_lines,center_locs)
%input= full kspace data, type of sampling,  total no.of  lines to be acquired
%output=reduced kspace data, sampling locations
% Swati D. Rane
% TAMU, Feb, 2004
%-------------------------------------------------
%----------------------------------------------
% Copyright (C) 2005 Jim Ji, Texas A&M University.
% All Rights Reserved.

% References:


% Version of 4-June-2005.

% Log:
% Created  2004 Swati Rane	Source code
% Updated
%-----------------------------------------------------
%------------------------------------------------------------------------
[Nx,Ny,num_coils]=size(full_kspace_data);
% the Misc.sampling location is the subsampling location; need to take care of
% the even/odd reduction factor; make sure that the central k-space
% (Ny/2+1) is sampled and the subsmapled phase-encodings is an even number.
switch samp
    case 2
         sampling_location=[ceil(Ny/2-num_lines/2):ceil(Ny/2+num_lines/2-1)];   
    case 3
         sampling_location=[ceil(Ny/2-num_lines):2:ceil(Ny/2+num_lines-1)];
         zer=find(sampling_location~=0);
         [trash len]=size(zer);
         [trash lens]=size(sampling_location);
         if(len~=lens)
             temp_samp=sampling_location(zer);
             [trash lent]=size(temp_samp);
             while (temp_samp(lent)+1<=Ny)
                 temp_samp(lent+1)=temp_samp(lent)+1;
                 [trash lent]=size(temp_samp);
             end
             clear sampling_location;
             sampling_location=temp_samp;
         end    
     case 4
    %sampling_location=[1:4:Ny/4 Ny/4+1:2:3*Ny/4 3*Ny/4+3:4:Ny];
     n_lines=ceil(num_lines/6);
        tp1=Ny/2-ceil(n_lines):Ny/2+floor(n_lines)-1;
        tp2(1)=Ny/2-ceil(n_lines)-2;
        
        tp3(1)=Ny/2+ceil(n_lines/2)+2;
        for(tp=2:ceil(n_lines))
            if(tp2(tp-1)-2>0)
                tp2(tp)=tp2(tp-1)-2;
            end
            if(tp3(tp-1)+2<=Ny)
                tp3(tp)=tp3(tp-1)+2;
            end
        end
        tp4(1)=Ny/2-2*ceil(n_lines)-4;
        tp5(1)=Ny/2+2*ceil(n_lines)+4;
        for(tp=2:ceil(n_lines))    
            tp;
            if(tp4(tp-1)-4>0)
                tp4(tp)=tp4(tp-1)-4;
            else
                tp4(tp)=tp4(tp-1);
            end
            if(tp5(tp-1)+4<=Ny)
                tp5(tp)=tp5(tp-1)+4;
            else
                tp5(tp)=tp5(tp-1);
            end
        end  
        t1=union(union(union(tp1,tp2),union(tp2,tp3)),union(tp4,tp5));
        clear sampling_location;
        sampling_location=sort(t1);
        [trash lens]=size(sampling_location);
        if(lens<num_lines)
            deficit=num_lines-lens;
            extra=Ny/2-ceil(n_lines)-1-ceil(deficit/2):Ny/2-ceil(n_lines)-2+2*n_lines+ceil(deficit/2);
            sampling_location=sort(union(sampling_location,extra));
        elseif(lens>num_lines)
            t2=sampling_location(1:num_lines);
            clear sampling_location;
            sampling_location=t2;
        end
    case 5
        sampling_location=union(sampling_location, center_locs);
  end

    for coil = 1:size(full_kspace_data,3)
       reduced_kspace_data(:,:,coil) = full_kspace_data(:,sampling_location,coil);
    end

return
