
%Swati D. Rane 
%April 8, 2005
%----------------------------
%----------------------------------------------
% Copyright (C) 2005 Jim Ji, Texas A&M University.
% All Rights Reserved.

% References:


% Version of 4-June-2005.

% Log:
% Created  2005 Swati Rane	Source code
% Updated
%-----------------------------------------------------
clc;
clear all;
close all;
startup;

Inputs_List;
if option==4
    Misc.mcmli=1;
    if(Flags.mcmli_flag==1)
        Misc.mcmli=input('How many columns to consider for MCMLI reconstruction for GRAPPA? ');
    end
end
Misc.second_acq=0;
Misc.cntr=1;
Misc.two_acq='y';
%-------------check for errors in inputs--------------
error_flag=Error_chk(data_type,Flags,Receiver,Sampling,per_list,Misc,option);

%-----------------------------------------------------
switch error_flag
    case 0
     
         %------------------------------------
         %kspace data collection
         disp('Loading files and generating kspace data...');
         [full_kspace_data,reduced_kspace_data,Sampling, Image_size,Receiver]...
             =get_kspace_data(data_type,Files,Flags,Receiver,Sampling,Misc,per_list,Image_size) ;

         %-------------------------------------
         %sensitivity estimation
         if(option~=4 || (option==3&&Flags.auto_smash_flag==1))
             disp('Estimating sensitivity...');
         end
         [Receiver,regularization_image]...
             =sensitivity_estimation_process(data_type,option,full_kspace_data, reduced_kspace_data,Receiver,Image_size,Files,Sampling,Flags,Misc,per_list);
           
         %------------------------------------
         % image reconstruction
         disp('Reconstructing image...');
         tic;
         [I_rec, Misc]...
             =reconstruct_image(option, data_type,full_kspace_data,reduced_kspace_data,Receiver,Sampling,Flags,per_list,regularization_image,Misc,Image_size);
         toc
         %------------------------------------
         %performance analysis
         if(per_list~=6)
             disp('Evaluating method...');
         end
            Perform_parameters=evaluate_method(data_type,Files,I_rec,Misc,per_list);
         
                 

    case 1
        disp('Please correct errors first!');
end