function temp_col=gencol_gen(nacs,kspread,Sampling,Npe,Nfe,start,i,column,num_coils,consider_coils,take_cols,Misc,bk)
% Swati D. Rane
% TAMU, July, 2004
%---------------------------------------------------
% Copyright (C) 2005 Jim Ji, Texas A&M University.
% All Rights Reserved.

% References:Generalized Autocalibrating Partially Parallel Acquisitions (GRAPPA)
%                    M. Griswold
%                    Magnetic Resonance in Medicne, 47:1202-1210 (2002)
%            MCMLI: An Improved Reconstruction Method forAuto-calibrating Partially Parallel Imaging
%                   Z Wang, JJ Wang, JA Detre, ISMRM 2005, 

% Version of 4-June-2005.

% Log:
% Created  2004 Swati Rane	Source code
% Updated
%-----------------------------------------------------
%----------------------------------------------------
% same as genmat_gen.m but to get coil sensivitvity values to be used for
% reconstructing missed lines
% only 2 neighbouring acquired lines are considered per ACS lines
%-------------------------------------------------------------------------
switch bk
    case 1
        start=start-Sampling.subsampling_factor*(Misc.blocks/2-1);
    case 2
        start=start-Sampling.subsampling_factor*(Misc.blocks/2-1)-Sampling.subsampling_factor;
    case 3
        start=start-Sampling.subsampling_factor*(Misc.blocks/2-1)+Sampling.subsampling_factor;
    case 4
        start=start-Sampling.subsampling_factor*(Misc.blocks/2-1)+2*Sampling.subsampling_factor;
end
r=0;
if(i<=ceil(consider_coils/2))
   take=[1:consider_coils];
elseif(i+ceil(consider_coils/2)>num_coils)
   take=[num_coils-consider_coils+1:num_coils];
else
   take=[i-ceil(consider_coils/2)+1:i+ceil(consider_coils/2)];
end

   for jt=take(1):take(consider_coils)
        ksptemp=kspread(:,take_cols(column,:),jt);
        if start+(nacs/4)*Sampling.subsampling_factor+nacs/2 >=Npe
            temp=start+(nacs/4)*Sampling.subsampling_factor-Npe;
            ksptemp(ceil(Npe+temp+nacs/2),:)=0;
            [Npe1 Nfe1]=size(kspread);
            pos=start;
        else
            ksptemp=kspread(:,take_cols(column,:),jt);
            Npe1=Npe;
            Nfe1=Nfe;
            pos=start;
        end
        for(m=1:Misc.blocks)           %nacs/2
           if pos<=0
              temp_col(r+1,:)=0;
              [r trash]=size(temp_col);
           elseif pos>Npe
              temp_col(r+1,:)=0;
              [r trash]=size(temp_col);
           else
             cp=1;
             %for(c=1:Misc.mcmli)
                 temp_col(r+1,cp:cp+Misc.mcmli-1)=ksptemp(pos,:);
              %   cp=cp+Misc.mcmli;
              %end               
             [r trash]=size(temp_col);
           end
           pos=pos+Sampling.subsampling_factor;        
        end      
    end

return