function temp_coil=genmat_gen(nacs,kspread,Sampling,Npe,Nfe,start,i,num_coils,consider_coils,take_cols,Misc)
%Swati D. Rane
%TAMU, July, 2004
%----------------------------------------------------------
%---------------------------------------------------
% Copyright (C) 2005 Jim Ji, Texas A&M University.
% All Rights Reserved.

% References:Generalized Autocalibrating Partially Parallel Acquisitions (GRAPPA)
%                    M. Griswold
%                    Magnetic Resonance in Medicne, 47:1202-1210 (2002)
%            MCMLI: An Improved Reconstruction Method forAuto-calibrating Partially Parallel Imaging
%                   Z Wang, JJ Wang, JA Detre, ISMRM 2005, 

% Version of 4-June-2005.

% Log:
% Created  2004 Swati Rane	Source code
% Updated
%-----------------------------------------------------
% generates the matrix of coil sensitivity values to solve
% simultaneously for the coefficents for reconstructing missed lines
% input= nacs, spread kspace data, PEs, FEs,total coils, ciols for coeff.
% calculation
%-----------------------------------------------------------------------

r=0;
if(i<=ceil(consider_coils/2))
   take=[1:consider_coils];
elseif(i+ceil(consider_coils/2)>num_coils)
   take=[num_coils-consider_coils+1:num_coils];
else
   take=[i-ceil(consider_coils/2)+1:i+ceil(consider_coils/2)];
end
 for n=1:floor(nacs/(Sampling.subsampling_factor-1))%JAn 22, 2005
   for j=take(1):take(consider_coils)
        ksptemp=kspread(:,:,j);
        if start+(nacs/4)*Sampling.subsampling_factor+nacs/2 >=Npe
            temp=start+(nacs/4)*Sampling.subsampling_factor-Npe;
            ksptemp(Npe+temp+nacs/2,:)=0;
            [Npe1 Nfe1]=size(kspread);
            pos=start;
        else
            ksptemp=kspread(:,:,j);
            Npe1=Npe;
            Nfe1=Nfe;
            pos=start;
        end
        for(m=1:Misc.blocks)%nacs/2 %mcmli addition
           if pos<=0
              temp_coil(r+1,:)=zeros(1,Nfe*Misc.mcmli);
              [r trash]=size(temp_coil);
           elseif pos>Npe
              temp_coil(r+1,:)=zeros(1,Nfe*Misc.mcmli);
              [r trash]=size(temp_coil);
           else
               cp=1;
               for(c=1:Nfe)
                 temp_coil(r+1,cp:cp+Misc.mcmli-1)=ksptemp(pos,take_cols(c,:));
                 cp=cp+Misc.mcmli;
               end
               [r trash]=size(temp_coil);
           end
           pos=pos+Sampling.subsampling_factor;        
        end      
    end
    start=start+Sampling.subsampling_factor;
end
return