function recon_final=grappa(kspread,nacs,acs,start_acs_row,consider_coils,Sampling,Misc)
%Swati D Rane
%TAMU, Modified Jan.24, 2005
%---------------------------------------
%---------------------------------------------------
% Copyright (C) 2005 Jim Ji, Texas A&M University.
% All Rights Reserved.

% References:Generalized Autocalibrating Partially Parallel Acquisitions (GRAPPA)
%                    M. Griswold
%                    Magnetic Resonance in Medicne, 47:1202-1210 (2002)
%            MCMLI: An Improved Reconstruction Method for Auto-calibrating Partially Parallel Imaging
%                   Z Wang, JJ Wang, JA Detre, ISMRM 2005, 

% Version of 4-June-2005.

% Log:
% Created  2004 Swati Rane	Source code
% Updated
%-----------------------------------------------------

% input=spread kspace data
% rearranged ACs data ->nacs
% start location of ACS lines ->start_acs_row
% no. of coils selected for coeff. calculation -> consider_coils,
%sampling locations
%----------------------------------------
%output= GRAPPa reconstruction
%-----------------------------------------
%THE ACS LINES ARE TAKEN  ON A PER COLUMN BASIS. THE RECONSTRUCTION
%COEFFICIENTS FOR THE PARTICULAR COLUMN ARE CALCULATED USING genmat_gen.m. THEN
%THE MISSING LINES ARE CALCULATED BY CONSIDERING THE CORRESPONDING ACQUIRED
%LINES SELECTED THORUGH gencol_gen.m
%-----------------------------------------
samp=Sampling.sampling_location(:);
clear Sampling.sampling_location;
Sampling.sampling_location=samp;
[siz trash]=size(Sampling.sampling_location);

%----------------mcmli addition--------------------
 [R C num_coils]=size(kspread);
 for(cols=1:C)
     if(cols<=ceil(Misc.mcmli/2))
       tcp=[1:Misc.mcmli];
    elseif(cols+ceil(Misc.mcmli/2)>C)
       tcp=[cols-Misc.mcmli+1:C];
    else
       tcp=[cols-ceil(Misc.mcmli/2)+1:cols+ceil(Misc.mcmli/2)];
     end
        take_cols(cols,:)=tcp(1:Misc.mcmli);
        clear tcp;
 end
%------------------------------------------------------
        

%start=start_acs_row-ceil(nacs/2)*Sampling.subsampling_factor-1; Jan 22,
for(bk=1:Misc.recons)
    switch bk
        case 1
            start=start_acs_row-(Sampling.subsampling_factor)*(Misc.blocks/2-1);
        case 2
            start=start_acs_row-(Sampling.subsampling_factor)*(Misc.blocks/2-1)-Sampling.subsampling_factor;
        case 3
            start=start_acs_row-(Sampling.subsampling_factor)*(Misc.blocks/2-1)+Sampling.subsampling_factor;
        case 4
            start=start_acs_row-(Sampling.subsampling_factor)*(Misc.blocks/2-1)+2*Sampling.subsampling_factor;
    end
    %stop=start+Sampling.subsampling_factor;
    [Npe Nfe num_coils]=size(kspread);               
    for(i=1:num_coils)
         p=0;
         %genmat_gen= funtion to generate matrices per group of coil
         %---------------------------------------------------------------------
         coil_mat(:,:,i)=genmat_gen(nacs,kspread,Sampling,Npe,Nfe,start,i,num_coils,round(consider_coils),take_cols,Misc);
         %-------------------------------------------------------
         %coil_mat(:,:,i)=temp_coil;
         [p trash1 trash2]=size(coil_mat(:,:,i));
    end
    %--------------------------------------
    clear ksptemp;
    clear ktemp;
    r=0;
    recon=zeros(Npe,Nfe);
    %Sampling.sampling_location(:);
    for i=1:num_coils%%%%%%%%%%
        i
%         for(column=1:Nfe)
%                 temp1=coil_mat(:,column,i);
%                 temp1=temp1(1:consider_coils*Misc.blocks*nacs/(Sampling.subsampling_factor-1));% Jan 22, 2005            
%                 coil_mtrx=transpose(reshape(temp1,[consider_coils*Misc.blocks floor(nacs/(Sampling.subsampling_factor-1))]));% Jan 22, 2005
%                 inv_coil_mtrx(:,:,column,i)=pinv(coil_mtrx);
%             end
            cp2=1;
            for column=1:Nfe
                temp1=coil_mat(:,cp2:cp2+Misc.mcmli-1,i);
                temp1=temp1(1:consider_coils*Misc.blocks*nacs/(Sampling.subsampling_factor-1),:);         
                cp4=1;
                for(cp3=1:Misc.mcmli)
                   coil_mtrx(:,cp4:cp4-1+Misc.blocks*consider_coils)=transpose(reshape(temp1(:,cp3),[consider_coils*Misc.blocks floor(nacs/(Sampling.subsampling_factor-1))])) ;
                   cp4=cp4+Misc.blocks*consider_coils;
                end
                   inv_coil_mtrx=pinv(coil_mtrx);
                take_acs=0;
                for j=1:Sampling.subsampling_factor-1
                    
                    for(row=Sampling.sampling_location(1):Sampling.subsampling_factor:Sampling.sampling_location(siz))%Aug 2 
                        %acs_col=acs(take_acs+1:take_acs+nacs/(Sampling.subsampling_factor-1),column,i);%Jan 22, 2005
                        acs_col=acs(take_acs+1:take_acs+nacs/(Sampling.subsampling_factor-1),column,i);%April 4, 2005
                        coeff_col(:,:)=inv_coil_mtrx*acs_col;                                 
                        temp=0;
                        start=row;
                        %to generate a vector of coil coefficients
                        %------------------------------------------------------
                        coil_col2=gencol_gen(nacs,kspread,Sampling,Npe,Nfe,start,i,column,num_coils,round(consider_coils),take_cols,Misc,bk);
                        coil_col=(coil_col2(:));
                        %------------------------------------------------------
                        [r1 trash]=size(coil_col);
                        [r2 trash]=size(coeff_col);
                        if(r1>r2)
                            col_coil=coil_col(1:r2,:);
                            clear coil_col;
                            coil_col=col_coil;
                            clear col_coil;
                        end                                                                   
                        kspread(row+j,column,i)=transpose(coil_col)*coeff_col;
                        [Npe Nfe]=size(recon);
                        clear coil_col;clear ksptemp;clear ktemp;
                    end
                    take_acs=take_acs+nacs/(Sampling.subsampling_factor-1);%Jan 22, 2005
                end
                clear temp1;   
                cp2=cp2+Misc.mcmli;
            end
    end

    for(i=1:num_coils)
        I_recon(:,:,i)=abs(ifftshift(ifft2(ifftshift(kspread(:,:,i))))).^2;
    end
    recon_i(:,:,bk)=sqrt(sum(I_recon,3)/num_coils);
end
%--------for signal-----------------
if(Misc.recons>1)
    SNR_image=recon_i(:,:,1);
    imagesc(abs(SNR_image));
    disp('Select the ROI to calculate mean signal intensity. ');
    [x_co, y_co]=ginput(2);
    SNR_image(round(y_co(1):y_co(2)),round(x_co(1)))=max(SNR_image(:));
    SNR_image(round(y_co(1):y_co(2)),round(x_co(2)))=max(SNR_image(:));
    SNR_image(round(y_co(1)),round(x_co(1):x_co(2)))=max(SNR_image(:));
    SNR_image(round(y_co(2)),round(x_co(1):x_co(2)))=max(SNR_image(:));
    imagesc(abs(SNR_image));colormap('gray');


    %---for noise------------------------------------
    disp('Select the background area to calculate noise.');
    [x_co1, y_co1]=ginput(2);
    SNR_image(round(y_co1(1):y_co1(2)),round(x_co1(1)))=max(SNR_image(:));
    SNR_image(round(y_co1(1):y_co1(2)),round(x_co1(2)))=max(SNR_image(:));
    SNR_image(round(y_co1(1)),round(x_co1(1):x_co1(2)))=max(SNR_image(:));
    SNR_image(round(y_co1(2)),round(x_co1(1):x_co1(2)))=max(SNR_image(:));
    imagesc(abs(SNR_image));colormap('gray');
    
    
    for(bks=1:Misc.blocks)
        signal_region= recon_i(round(y_co(1):y_co(2)),round(x_co(1):x_co(2)),bks);
        noise_region= recon_i(round(y_co(1):y_co(2)),round(x_co(1):x_co(2)),bks);
        sig=mean2(signal_region);
        noi=std2(noise_region);
    
        SNRvalue(bks)=abs(10*log10((sig/noi).^2));
        SNRImg(:,:,bks)=SNRvalue(bks).*recon_i(:,:,bks);
    end
    
    SNRtot=SNRvalue(:);
    sum_snr=sum(SNRtot);
    sum_img=sum(SNRImg,3);
    recon_final=sum_img./sum_snr;
else
    recon_final=recon_i;
end


save parameters;
return