function[kspread,acs,start_acs_row,consider_coils,nacs,Misc]=prepare_grappa2(full_kspace_data,reduced_kspace_data,Sampling,Receiver,data_type,Image_size,Misc);
% Swati D. Rane
% TAMU, July, 2004
%---------------------------
%---------------------------------------------------
% Copyright (C) 2005 Jim Ji, Texas A&M University.
% All Rights Reserved.

% References:Generalized Autocalibrating Partially Parallel Acquisitions (GRAPPA)
%                    M. Griswold
%                    Magnetic Resonance in Medicne, 47:1202-1210 (2002)
%            MCMLI: An Improved Reconstruction Method forAuto-calibrating Partially Parallel Imaging
%                   Z Wang, JJ Wang, JA Detre, ISMRM 2005, 

% Version of 4-June-2005.

% Log:
% Created  2004 Swati Rane	Source code
% Updated
%-----------------------------------------------------
%input=full_ksapce_data and reduced_kspace_data.If only one is availeble,
%other=0;
%sampling locations along the phase encoding direction ->sampling_lcation
%subsampling_factor
%typr of data input ->data_type
%---------------------------------------
%output=the reduced kspace data spread out so that evry line is in the
%correct sampling position ->kspread
%the location o the first ACs line ->start_acs_row
%the number of coils considered for reconstruction of the missing lines
%->consider_coils
%------------------------------------------
%THE LOCATION OF THE ACS LINES IS DETERMINED. THEY ARE ARRANGED IN A
%PARTICULAR ORDER TO ENABLE EASY USE DURING RECONSTRUCTION.
%-------------------------------------------
[Ro, trashp, num_coils]=size(reduced_kspace_data);
C=Image_size.PEs;
for(i=1:num_coils)
    kspread(1:C,1:Ro,i)=0;
    %reduced_kspace_data1(:,:,i)=ifftshift(ifft(ifftshift(transpose(reduced_kspace_data(:,:,i)),2),[],2),2);
    reduced_kspace_data1(:,:,i)=transpose(reduced_kspace_data(:,:,i));
    if(data_type~=4)
        full_kspace_data1(:,:,i)=transpose(full_kspace_data(:,:,i));
    else
        full_kspace_data1=0;
    end
    kspread(Sampling.sampling_location,:,i)=reduced_kspace_data1(:,:,i);
end
clear full_kspace_data;
full_kspace_data=full_kspace_data1;
%save parameters full_kspace_data '-append';
clear full_kspace_data1;

switch (data_type)
    case {1,2}
        %----------------------------------------------------------
        actual_lines=round(C/2-Sampling.center_lines/2+1:C/2+Sampling.center_lines/2);
        inter=intersect(actual_lines, Sampling.sampling_location);
        
        [trash len]=size(actual_lines);
        [trash len2]=size(inter);
        k=1;
        for(i=1:len)
            chk=actual_lines(i)==inter;
            chk_sum=sum(chk(:));
            if(chk_sum==0)
                take_lines(k)=actual_lines(i);
                k=k+1;
            end
        end
        Sampling.sampling_location;
        take_lines;
        [trash len]=size(take_lines);
        poss_nacs=len;
        %find out how many nacs you have
        %--------------------------------------------------
        clear chk; 
        clear chk_sum;
        temp=take_lines;
        for(i=1:Sampling.subsampling_factor)
            temp=temp+1;
            chk=temp(1)==Sampling.sampling_location;
            chk_sum=sum(chk(:));
            if(chk_sum~=0)
                switch i
                    case Sampling.subsampling_factor-1
                        temp2=poss_nacs/(Sampling.subsampling_factor-1);
                        if(floor(temp2)==ceil(temp2))
                            nacs=temp2*(Sampling.subsampling_factor-1);
                            nacs_locs=take_lines(1:nacs);
                        else
                            nacs=floor(temp2)*(Sampling.subsampling_factor-1)
                            nacs_locs=take_lines(1:nacs)
                        end
                    otherwise
                        temp_nacs=poss_nacs-i;
                        temp2=temp_nacs/(Sampling.subsampling_factor-1);
                        if(floor(temp2)==ceil(temp2))
                            nacs=temp2*(Sampling.subsampling_factor-1);
                            nacs_locs=take_lines(i+1:i+nacs);
                        else
                            nacs=floor(temp2)*(Sampling.subsampling_factor-1)
                            nacs_locs=take_lines(i+1:i+nacs);
                        end
                end
            end
        end
        if nacs==0
           cen=C/2+1;
           start_cen=cen-Sampling.subsampling_factor;
           nacs=Sampling.subsampling_factor-1;
           nacs_locs=start_cen+1:cen-1;
       end
        locs_nacs=transpose(reshape(nacs_locs,[(Sampling.subsampling_factor-1) floor(nacs/(Sampling.subsampling_factor-1))]))
        %get locations of nace in an order , easy to use for calculating
        %coefficients
        arrange_nacs=locs_nacs(:);
        for(i=1:num_coils)
            %collect extra ACS lines
            %acs(:,:,i)=ifftshift(ifft(ifftshift(full_kspace_data(arrange_nacs,:,i),2),[],2),2);% nothing but extra calibration lines
            acs(:,:,i)=full_kspace_data(arrange_nacs,:,i);% nothing but extra calibration lines
        end
    case 4
        %load parameters;
        inter=intersect(Sampling.center_locs, Sampling.sampling_location);
        
        [trash len]=size(Sampling.center_locs);
        [trash len2]=size(inter);
        k=1;
        for(i=1:len)
            chk=Sampling.center_locs(i)==inter;
            chk_sum=sum(chk(:));
            if(chk_sum==0)
                take_lines(k)=Sampling.center_locs(i);
                k=k+1;
            end
        end
        nacs_locs=take_lines;
        
        [trash nacs]=size(nacs_locs);
        %--------added March 12, 2005-----------
        take_lines=nacs_locs;
        [trash len]=size(take_lines);
        poss_nacs=len;
        clear chk; 
        clear chk_sum;
        temp=take_lines;
        for(i=1:Sampling.subsampling_factor)
            temp=temp+1;
            chk=temp(1)==Sampling.sampling_location;
            chk_sum=sum(chk(:));
            if(chk_sum~=0)
                switch i
                    case Sampling.subsampling_factor-1
                        temp2=poss_nacs/(Sampling.subsampling_factor-1);
                        if(floor(temp2)==ceil(temp2))
                            nacs=temp2*(Sampling.subsampling_factor-1);
                            nacs_locs=take_lines(1:nacs);
                        else
                            nacs=floor(temp2)*(Sampling.subsampling_factor-1)
                            nacs_locs=take_lines(1:nacs)
                        end
                    otherwise
                        temp_nacs=poss_nacs-i;
                        temp2=temp_nacs/(Sampling.subsampling_factor-1);
                        if(floor(temp2)==ceil(temp2))
                            nacs=temp2*(Sampling.subsampling_factor-1);
                            nacs_locs=take_lines(i+1:i+nacs);
                        else
                            nacs=floor(temp2)*(Sampling.subsampling_factor-1)
                            nacs_locs=take_lines(i+1:i+nacs);
                        end
                end
            end
        end
        %locs_nacs=transpose(reshape(nacs_locs,[(Sampling.subsampling_factor-1) nacs/(Sampling.subsampling_factor-1)]))
        %get locations of nace in an order , easy to use for calculating
        %coefficients
        %arrange_nacs=locs_nacs(:);commented March 12,  2005
        locs_nacs=transpose(reshape(nacs_locs,[(Sampling.subsampling_factor-1) floor(nacs/(Sampling.subsampling_factor-1))]));
        %get locations of nace in an order , easy to use for calculating
        %coefficients
        arrange_nacs=locs_nacs(:);
        %-------added March 12, 2005--------------------
        for(i=1:num_coils)
            temp_data(:,:,i)=zeros(Ro,C);
            temp_data(:,Sampling.center_locs,i)=(Receiver.center_data(:,:,i));
            %collect extra ACS lines
            acs(:,:,i)=(transpose(temp_data(:,arrange_nacs,i)));%center data has PEs along columns
            % this program requires PEs along row
        end
     case 3% added you have coil maps separately ful; kspace data but no set of extra ACS lines
        %load parameters;
         inter=intersect(Sampling.center_locs, Sampling.sampling_location);
        
        [trash len]=size(Sampling.center_locs);
        [trash len2]=size(inter);
        k=1;
        for(i=1:len)
            chk=Sampling.center_locs(i)==inter;
            chk_sum=sum(chk(:));
            if(chk_sum==0)
                take_lines(k)=Sampling.center_locs(i);
                k=k+1;
            end
        end
        nacs_locs=take_lines;
        [trash nacs]=size(nacs_locs);
        %n_len=nacs;
        while((Sampling.subsampling_factor-1)*floor(nacs/(Sampling.subsampling_factor-1))~=nacs)
            temp=nacs_locs;
            clear nacs_locs;
            nacs_locs=temp(2:nacs);
            [trash nacs]=size(nacs_locs);
        end
        locs_nacs=transpose(reshape(nacs_locs,[(Sampling.subsampling_factor-1) floor(nacs/(Sampling.subsampling_factor-1))]));
        %get locations of nace in an order , easy to use for calculating
        %coefficients
        arrange_nacs=locs_nacs(:);
        
        for(i=1:num_coils)
            %if(Receiver.center_data==0)
                acs(:,:,i)=full_kspace_data(arrange_nacs,:,i);% nothing but extra calibration lines
                %else
%                 temp_data(:,:,i)=zeros(Ro,C);
%                 temp_data1(:,Sampling.center_locs,i)=(Receiver.center_data(:,:,i));
%                 temp_data(:,nacs_locs,i)=temp_data1(:,nacs_locs,i);
%                 %collect extra ACS lines
                %acs(:,:,i)=ifftshift(ifft(ifftshift(transpose(temp_data(:,arrange_nacs,i)),2),[],2),2);%center data has PEs along columns
%                 acs(:,:,i)=(transpose(temp_data(:,arrange_nacs,i)));%center data has PEs along columns
                % this program requires PEs along row
%             end
        end
        clear temp_data;
        
end
%---get the correct nacs---------------------------------------------------
%--------------------------------------------------------------------------
consider_coils=round(nacs-Misc.blocks)/Misc.blocks);
%consider_coils=(nacs/(Sampling.subsampling_factor-1)-Misc.blocks)/Misc.blocks;%to make the system over-determined and hence better conditioned.
if(consider_coils>num_coils)%added subsampling_factor term here
  consider_coils=num_coils;
end
% if(Misc.blocks*consider_coils < nacs)
%     Misc.blocks=1;
%     consider_coils=1;
% end
%consider_coils=3;
start_acs_row=locs_nacs(1)-1;

save parameters;
return;
                
                
 
 
    
    
    

