function recon=spacerip(reduced_kspace_data,Receiver,Sampling)
%function for SPACE RIP simulation
%here PE is along X axis
%since the kspacedata_sim function is designed for PE in the Y direction
%transpose of the image is taken
%-----------------------------------
%Swati D. Rane,  TAMU
%Aug. 27, 2004
%-----------------------------------
%----------------------------------------------
% Copyright (C) 2005 Jim Ji, Texas A&M University.
% All Rights Reserved.

% References:Sensitivity Profiles from an Array of Coils for Encoding and
%                   Reconstructioin in Parallel
%                    W. Kyriakos, M. Panych
%                    Magnetic Resonance in Medicine, 44:301-308 (2000)

% Version of 4-June-2005.

% Log:
% Created  2004 Swati Rane	Source code
% Updated
%-----------------------------------------------------
% input= reduced kspace data
% coil maps->rough_maps/dimension (actual PEs and FEs)
% sampling locations along the phase encoding ->sampling_location
%-----------------------------------
% output= SPACE RIP Reconstruction
%-----------------------------------
%UNIFORM OR NON-UNIFORM SAMPLING OF KSAPCE IS FIRST SELECTED USING
%subsamp_gen.m.USUALLY THE OPTIONS 2 AND 3 I.E. ONLY CENTRAL KSPACE LINES
%OR ALTERNATE LINES BUT IN THE CENTER OF THE KSPACE RESULTS IN A VARY HIGH
%CONDITION NUMBER AND HENCE POOR RECONSTRUCTION
%------------------------------------



%Since here the PE direction is along Y.Prof.Ji's algos have PE along X
%direction
[Ro C num_coils]=size(Receiver.rough_map);
for(l=1:num_coils)
        reduced_kspace_data1(:,:,l)=transpose(reduced_kspace_data(:,:,l));       
        sensitivity(:,:,l)=transpose(Receiver.rough_map(:,:,l));
end
[Ro C num_coils]=size(sensitivity);

%reduced_kspace_data1 = ifftshift(reduced_kspace_data1,1);
%
% convert sampling_location from [-pi pi] to [0 2pi] used in dft matrix

samploc_dft = (Sampling.sampling_location-Ro/2);
tmp = find(samploc_dft<=0);
samploc_dft(tmp) = samploc_dft(tmp) + Ro;
%---matrix of dft coefficients--------    

df=dftmtx(Ro);

df_reduced=df(samploc_dft,:); %taking care of the fourier coefficients along with the interval
 
 %--------------------------------------
    for(nrec=1:num_coils)
        S_half(:,:,nrec)=ifftshift(ifft(ifftshift(reduced_kspace_data1(:,:,nrec),2),[],2),2);
        %1D fft along the FE direction
        [Rnew C]=size(S_half(:,:,nrec));
    end  

%--coil reconstruction-----------------
for col=1:C
    k=0;
    for(nrec=1:num_coils)
        Sfull(k+1:k+Rnew,:)=S_half(:,col,nrec);
        tmp=repmat(transpose(sensitivity(:,col,nrec)),[Rnew 1]);
        tmp=fftshift(tmp,2);%**See note
        Wfull(k+1:k+Rnew,:)=tmp.*df_reduced;
        k=k+Rnew;
    end
    Winv=pinv(Wfull);
    condn=cond(Winv);
%      [U,S,V]=svd(Winv);    
%      S=S.*(S>0.05*max(S(:)));
%      Winv=U*S*V';
    Irec(:,col)=Winv*Sfull;
end       

%**This is because when simulating reduced kspace data, the modulated image
%is fftshifted before FT.

recon = fftshift(Irec,1); 

% figure(1); imagesc(transpose(image)); colormap('gray'); colorbar;
% figure(2); imagesc(abs(Irec));colormap('gray'); colorbar
% figure(3); imagesc(abs(transpose(image)-Irec)); colormap('gray'); colorbar;

return